package hu.kozadat.search.base.renderer;

import hu.kozadat.search.model.ResultItem;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * Olyan renderer, amely tovabbi elemeket ki tud valasztani a listabol.
 *
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
@Deprecated
public class ChooseResultListItemRenderer implements ResultListItemRenderer {
    private final ResultItem errorItem;

    private Map rendererMap;
    private ResultListItemRenderer defaultRenderer;

    public ChooseResultListItemRenderer() {
        errorItem = new ResultItem();
        errorItem.setDataProvider("ismeretlen");
        errorItem.setId("0");
        errorItem.setMetadataType("ismeretlen");
        errorItem.setResultHtmlFragment("Nincs alkalmazható renderer");
    }

    public void setRendererMap(Map rendererMap) {
        this.rendererMap = new HashMap();
        for (Iterator iter = rendererMap.keySet().iterator(); iter.hasNext(); ) {
            String key = (String) iter.next();

            StringBuffer keyBuf = new StringBuffer(key.length() + 16);
            for (int i = 0; i < key.length(); i++) {
                char c = key.charAt(i);
                if (c > 127) {
                    keyBuf.append("&#");
                    keyBuf.append((int) c);
                    keyBuf.append(';');
                } else {
                    keyBuf.append(c);
                }
            }

            String newKey = keyBuf.toString();

            this.rendererMap.put(newKey, rendererMap.get(key));
        }
    }

    public void setDefaultRenderer(ResultListItemRenderer defaultRenderer) {
        this.defaultRenderer = defaultRenderer;
    }

    public ResultItem getResultItemFor(String resultText, int index, HttpServletResponse response) {
        ResultListItemRenderer applied = defaultRenderer;

        int schemaNamePos = resultText.indexOf("$schema_name=");
        if (schemaNamePos >= 0) {
            int endIndex = resultText.indexOf('\n', schemaNamePos);
            if (endIndex < 0) endIndex = resultText.length();

            String schemaName = resultText.substring(schemaNamePos + 13, endIndex).trim();

            if (rendererMap != null) {
                Object item = rendererMap.get(schemaName);
                if (item != null && item instanceof ResultListItemRenderer) {
                    applied = (ResultListItemRenderer) item;
                }
            }
        }

        return applied == null ? errorItem : applied.getResultItemFor(resultText, index, response);
    }
}
