package hu.kozadat.search.interactive;

import com.actiwise.einfoszab.Utils;
import hu.kozadat.search.Constants;

/**
 * User: codex
 */
public class KeywordSearchTerm implements IInteractiveSearchTerm {
    private String fieldName;
    private String expression;
    private String operator;

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public String getExpression() {
        return expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

    public String getOperator() {
        return operator;
    }

    public void setOperator(String operator) {
        this.operator = operator;
    }

    public String toQueryFragment(boolean isFirstTerm) {
        StringBuffer out = new StringBuffer();

        if (Constants.INTERACTIVE_SEARCH_TERM_OPERATOR_AND.equals(operator.toLowerCase())) {
            out.append("+");
        }
        if (fieldName != null && !"".equals(fieldName)) {
            out.append(Utils.normalizeFieldName(fieldName.trim())).append(":");
        }
//        if ( Utils.containsWhitespace( expression )) {
        out.append("\"").append(expression).append("\"");
//        } else {
//            out.append( expression );
//        }
        out.append(" ");

        return out.toString();
    }

    public boolean isEmpty() {
        return expression == null || "".equals(expression);
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(operator).append(" ");
        if (fieldName == null) {
            sb.append("'globális'");
        } else {
            sb.append(fieldName);
        }
        sb.append("=").append(expression).append(" ");
        return sb.toString();
    }


}
