package hu.kozadat.search.persistence.impl;

import hu.kozadat.search.persistence.StatisticOperations;
import hu.kozadat.search.persistence.core.RdbmsStatisticOperations;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.24.
 * Time: 12:19
 * To change this template use File | Settings | File Templates.
 */
@Repository
public class StatisticOperationsImpl implements StatisticOperations {

    private static final Logger LOGGER = LoggerFactory.getLogger(StatisticOperationsImpl.class);

    private JdbcTemplate jdbcTemplate;

    private RdbmsStatisticOperations rdbmsStatisticOperations;

    @Autowired
    public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
        this.rdbmsStatisticOperations = new RdbmsStatisticOperations();
        this.rdbmsStatisticOperations.setJdbcTemplate(this.jdbcTemplate);
    }

    public void updateOrInsertSearchQuery(String searchQuery) {
        rdbmsStatisticOperations.updateOrInsertSearchQuery(searchQuery);
    }

    public List<String> getPrevalentSearchExpressions(int count) {
        return rdbmsStatisticOperations.getPrevalentSearchExpressions(count);
    }

    public List<String> getRandomPrevalentSearchExpressions(int count, int randomInterval) {
        return rdbmsStatisticOperations.getRandomPrevalentSearchExpressions(count, randomInterval);
    }
}
