package hu.kozadat.search.presentation;

import org.springframework.web.util.UrlPathHelper;

import javax.servlet.http.HttpServletRequest;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2013.11.28.
 * Time: 12:18
 *
 * Source: https://jira.springsource.org/browse/SPR-11101
 */
public class NonDecodingUrlPathHelper extends UrlPathHelper {

    public NonDecodingUrlPathHelper() {
        super.setUrlDecode(false);
    }

    @Override
    public void setUrlDecode(boolean urlDecode) {
        if (urlDecode) {
            throw new IllegalArgumentException("Handler does not support URL decoding.");
        }
    }

    @Override
    public String getServletPath(HttpServletRequest request) {
        return getOriginatingServletPath(request);
    }

    @Override
    public String getOriginatingServletPath(HttpServletRequest request) {
        return request.getRequestURI().substring(request.getContextPath().length());
    }

}
