package hu.kozadat.search.presentation;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.nio.charset.Charset;
import java.util.Map;
import java.util.Set;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.11.10.
 * Time: 9:30
 * To change this template use File | Settings | File Templates.
 */
public class UrlUtils {

    private static final Charset CHARSET_UTF_8 = Charset.forName("UTF-8");

    private UrlUtils() {

    }

    public static String excludeParam(String path, HttpServletRequest httpServletRequest, String parameterNameToExclude) {
        StringBuilder stringBuilder = new StringBuilder(path);
        Map<String, String[]> parameterMap = httpServletRequest.getParameterMap();
        parameterMap.remove(parameterNameToExclude);
        Set<Map.Entry<String, String[]>> entries = parameterMap.entrySet();
        int i = 0;
        try {
            for (Map.Entry<String, String[]> entry : entries) {
                String parameterName = URLEncoder.encode(entry.getKey(), CHARSET_UTF_8.name());
                String[] parameterValues = entry.getValue();
                if (i == 0) {
                    stringBuilder.append("?");
                }
                if (i > 0) {
                    stringBuilder.append("&");
                }
                for (String parameterValue : parameterValues) {
                    if ((stringBuilder.lastIndexOf("?") != stringBuilder.length() - 1) && (stringBuilder.lastIndexOf("&") != stringBuilder.length() - 1)) {
                        stringBuilder.append("&");
                    }
                    stringBuilder.append(parameterName).append("=").append(URLEncoder.encode(parameterValue, CHARSET_UTF_8.name()));
                }
                i++;
            }
        } catch (UnsupportedEncodingException e) {
            throw new IllegalArgumentException(e.getMessage(), e);
        }
        return stringBuilder.toString();
    }

    public static String forwardTo(String url) {
        StringBuilder stringBuilder = new StringBuilder("forward:");
        stringBuilder.append(url);
        return stringBuilder.toString();
    }

    public static String redirectTo(String url) {
        StringBuilder stringBuilder = new StringBuilder("redirect:");
        stringBuilder.append(url);
        return stringBuilder.toString();
    }

}
