package hu.kozadat.search.presentation.institutionsearch;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.06.29.
 * Time: 11:14
 * To change this template use File | Settings | File Templates.
 */
public enum LetterGroup {

    A_F(LetterGroupConstants.LABEL_A_F, LetterGroupConstants.LETTERS_A_F),
    G_L(LetterGroupConstants.LABEL_G_L, LetterGroupConstants.LETTERS_G_L),
    M_R(LetterGroupConstants.LABEL_M_R, LetterGroupConstants.LETTERS_M_R),
    S_Z(LetterGroupConstants.LABEL_S_Z, LetterGroupConstants.LETTERS_S_Z),
    SPECIAL(LetterGroupConstants.LABEL_SPECIAL, LetterGroupConstants.LETTERS_SPECIAL);

    private String label;
    private List<String> letters;

    private LetterGroup(String label, String[] letters) {
        this.label = label;
        this.letters = Collections.unmodifiableList(Arrays.asList(letters));
    }

    public String getName() {
        return this.name();
    }

    public String getLabel() {
        return label;
    }

    public List<String> getLetters() {
        return letters;
    }

    public String[] getLettersArray() {
        return letters.toArray(new String[letters.size()]);
    }

    public static LetterGroup parse(String letterGroupName) {
        if (A_F.name().equalsIgnoreCase(letterGroupName)) {
            return A_F;
        } else if (G_L.name().equalsIgnoreCase(letterGroupName)) {
            return G_L;
        } else if (M_R.name().equalsIgnoreCase(letterGroupName)) {
            return M_R;
        } else if (S_Z.name().equalsIgnoreCase(letterGroupName)) {
            return S_Z;
        } else if (SPECIAL.name().equalsIgnoreCase(letterGroupName)) {
            return SPECIAL;
        } else {
            return null;
        }
    }
}
