package hu.kozadat.search.service.institutionsearch;

import hu.kozadat.search.model.InstitutionNameAutoCompleteData;
import hu.kozadat.search.persistence.core.InstitutionNameAutoCompleteOperations;
import hu.kozadat.search.service.SearchUIConfiguration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Set;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.07.04.
 * Time: 14:43
 * To change this template use File | Settings | File Templates.
 */
@Service
public class InstitutionNameAutoCompleteService {

    private static final Logger LOGGER = LoggerFactory.getLogger(InstitutionNameAutoCompleteService.class);

    private InstitutionNameAutoCompleteOperations institutionNameAutoCompleteOperations;
    private SearchUIConfiguration searchUIConfiguration;

    public Set<InstitutionNameAutoCompleteData> findByPrefix(String prefix) {
        return institutionNameAutoCompleteOperations.findByPrefix(prefix, searchUIConfiguration.getInstitutionSearchAutoCompleteLimit());
    }

    public int countByPrefix(String prefix) {
        return institutionNameAutoCompleteOperations.countByPrefix(prefix);
    }

    @Autowired
    public void setInstitutionNameAutoCompleteOperations(InstitutionNameAutoCompleteOperations institutionNameAutoCompleteOperations) {
        this.institutionNameAutoCompleteOperations = institutionNameAutoCompleteOperations;
    }

    @Autowired
    public void setSearchUIConfiguration(SearchUIConfiguration searchUIConfiguration) {
        this.searchUIConfiguration = searchUIConfiguration;
    }
}
