/**
 * Created by IntelliJ IDEA.
 * User: tnagy
 * Date: 2010.01.14.
 * Time: 11:26:24
 *
 * Descriptions from http://ge.images.alaska.edu/workshop/advanced.htm 
 */
package hu.kozadat.search.web.map;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

@XmlType(namespace = "http://www.opengis.net/kml/2.2", propOrder = {"longitude", "latitude", "altitude", "heading", "range", "tilt", "altitudeMode"})
public class LookAt {
    /**
     * Angle from -180 to 180 degrees
     * type=kml:angle180
     */
    private double longitude = 0;

    /**
     * Angle from -90 to 90 degrees
     * type=kml:angle90
     */
    private double latitude = 0;

    /**
     * Distance above earth's surface in meters; default=0
     */
    private double altitude = 0;

    /**
     * type=kml:angle360
     */
    private int heading = 0;

    /**
     * Distance in meters from the point specified by longitude,
     * latitude and altitude to the LookAt position
     */
    private int range;

    /**
     * type=kml:anglepos90 (0 = north, 90 = east, 180 = south, 270 = west)
     */
    private int tilt = 0;

    /**
     * Specifies how the altitude specified for the LookAt point is interpreted;
     * clampToGround, relativeToGround, absolute
     */
    private String altitudeMode = "clampToGround";

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "longitude")
    public double getLongitude() {
        return longitude;
    }

    public void setLongitude(double longitude) {
        this.longitude = longitude;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "latitude")
    public double getLatitude() {
        return latitude;
    }

    public void setLatitude(double latitude) {
        this.latitude = latitude;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "altitude")
    public double getAltitude() {
        return altitude;
    }

    public void setAltitude(double altitude) {
        this.altitude = altitude;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "heading")
    public int getHeading() {
        return heading;
    }

    public void setHeading(int heading) {
        this.heading = heading;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "range", required = true)
    public int getRange() {
        return range;
    }

    public void setRange(int range) {
        this.range = range;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "tilt")
    public int getTilt() {
        return tilt;
    }

    public void setTilt(int tilt) {
        this.tilt = tilt;
    }

    @XmlElement(namespace = "http://www.opengis.net/kml/2.2", name = "altitudeMode")
    public String getAltitudeMode() {
        return altitudeMode;
    }

    public void setAltitudeMode(String altitudeMode) {
        this.altitudeMode = altitudeMode;
    }
}
